Bug 837716 - clojure binary causes shell to exit when exiting the repl
clojure binary causes shell to exit when exiting the repl
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: clojure (Show other bugs)
17
All Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Colin Walters
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-04 20:18 EDT by Dan Allen
Modified: 2014-07-24 23:19 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-01 09:07:55 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dan Allen 2012-07-04 20:18:16 EDT
Description of problem:

Exiting from the repl (clojure -r) results in the termination of the shell session. On a local box, this closes the xterm (or gnome-terminal) window (or tab). On a remote box, this forces a logout.

This occurs because the clojure script (/usr/bin/clojure) is using "exec" to launch java. The "exec" command replaces the shell, so when the program (clojure) exits, the shell also exits.

As a result, the repl is very unfriendly to use.

Version-Release number of selected component (if applicable):

clojure-1.4.0-2.fc17.noarch

How reproducible:

Always.

Steps to Reproduce:

1. Launch clojure repl:

$ clojure

or

$ clojure -r

2. Exit the repl:

user=> (System/exit 0)

3. Observe that your xterm (or gnome-terminal) has closed, or that you have been disconnected from the remote shell

Expected results:

The clojure repl should terminate, but not the shell.

Additional info:

Here is what the contents of the /usr/bin/clojure script should be (note I have also replaced /bin/bash with /bin/sh)

#!/bin/sh

java ${JAVA_OPTS} -jar /usr/share/java/clojure.jar "$@"
Comment 1 Michel Alexandre Salim 2012-07-05 10:17:44 EDT
Curious -- I tried replicating this using both zsh and bash, and in both cases (System/exit 0) just returns me to the prompt without closing anything.

Is there anything specific to your configuration? I've been meaning to replace the clojure.sh script with %jpackage_script anyway, but let's try and find out what exactly is going on here first.
Comment 2 Michel Alexandre Salim 2012-07-05 10:33:49 EDT
Note that %jpackage_script uses exec as well (through 'run' which is defined in /usr/share/java-utils/java-functions) so I'm quite curious to find what's different in your configuration.

Could you check if on a new user account the same still occurs? And in that case, attach your shell initialization files (.bash_profile / .bashrc / etc.) ?
Comment 3 Dan Allen 2012-07-26 19:13:03 EDT
Curious, I can reproduce it now either. Hmmm. Since I reported the bug I upgraded to Fedora 17, so it could be that I was seeing it only Fedora 16.

Anyway, that problem seems to be resolved.

I'm in favor of replacing the script with the %jpackage_script. I'd say move forward with that. Handle this resolution of this issue as you see fit.
Comment 4 Fedora End Of Life 2013-07-04 00:18:00 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Fedora End Of Life 2013-08-01 09:08:00 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.